config/routes.rb
Rails.application.routes.draw do

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
  
  devise_for :users
  root 'static_pages#index'
  get 'unauthorized', to: 'static_pages#unauthorized'
  namespace :event_planner do 
    resources :events
  end
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/event.rb
class Event < ApplicationRecord
  validates :title, presence: true
  validates :venue, presence: true
  validates :address, presence: true
  validates :city, presence: true 
  validates :state, presence: true
  validates :country_select, presence: true
  validates :date, presence: true
  validates :arrival_time, presence: true
  validates :description, presence: true

  belongs_to :user
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  validates :first_name, presence: :true, length: {maximum: 30, minimum: 3}
  validates :last_name, presence: true, length: {maximum: 30, minimun: 3}

  has_many :events
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
   protect_from_forgery with: :exception

     before_action :configure_permitted_parameters, if: :devise_controller?

     protected

          def configure_permitted_parameters
               devise_parameter_sanitizer.permit(:sign_up) { |u| u.permit(:first_name, :last_name, :email, :password)}

               devise_parameter_sanitizer.permit(:account_update) { |u| u.permit(:first_name, :last_name, :email, :password, :current_password)}
          end
end

app/controllers/event_planner/events_controller.rb
class EventPlanner::EventsController < ApplicationController
before_action :authenticate_user!
# , only: [:new, :create, :edit, :update, :destroy, :show]

  def index
     @event = current_user.events
  end

  def new
    @event = Event.new
  end

  def create
    @event = current_user.events.create(event_params)
    if @event.valid?
      redirect_to event_planner_event_path(current_user)
    else
      render :new, status: :unprocessable_entity
    end
  end

  def show 
    # @event = Event.last
    # if @event.user != current_user 
    #   redirect_to unauthorized_path
    # end
  end


    private 

  def event_params 
    params.require(:event).permit(:title, :venue, :address, :city, :state, :country_select, :date, :arrival_time, :description)
  end

  def render_not_found(status=:not_found)
    render plain: "Unauthorized Access", status: status
  end
end

#   def show
#     @events = current_user.events

#       if @event.blank?
#         render plain: 'Page not found', status: :not_found
#       end
#     if @events.blank?
#       flash[:alert] = "Please Create an Event First"
#       redirect_to new_event_path
#     elsif @events.user != current_user
#       redirect_to unauthorized_path
#     end
#     return render_not_found(:forbidden) if @event.user != current_user
#   end

#   def edit 
#     @event = Event.find_by_id(params[:id])
#     return render_not_found if @event.blank?
#     return render_not_found(:forbidden) if @event.user != current_user
#   end 

#   def update
#     @event = Event.find_by_id(params[:id])
#     return render_not_found if @event.blank?
#     return render_not_found(:forbidden) if @event.user != current_user
#     @event.update_attributes(event_params)

#     if @event.valid?
#       redirect_to root_path
#     else
#       return render :edit, status: :unprocessable_entity
#     end
#   end

#   def destroy 
#     @event = Event.find_by_id(params[:id])
#     return render_not_found if @event.blank?
#     return render_not_found(:forbidden) if @event.user != current_user
#     @event.destroy
#     redirect_to root_path
#   end 

#   def new
#     @event = Event.new
#   end

#   def create
#     @event = current_user.events.create(event_params)
#     if @event.valid?
#       redirect_to event_path(current_user)
#     else
#       render :new, status: :unprocessable_entity
#     end
#   end
   
#   private 

#   def event_params 
#     params.require(:event).permit(:title, :venue, :address, :city, :state, :country_select, :date, :arrival_time, :description)
#   end

#   def render_not_found(status=:not_found)
#     render plain: "Unauthorized Access", status: status
#   end
# end

app/controllers/events_controller.rb
class EventsController < ApplicationController
before_action :authenticate_user!, only: [:new, :create, :edit, :update, :destroy, :show]

  def index
   
  end

  def show
    # @events = current_user.events

      # if @event.blank?
      #   render plain: 'Page not found', status: :not_found
      # end
    # if @events.blank?
    #   flash[:alert] = "Please Create an Event First"
    #   redirect_to new_event_path
    # elsif @events.user != current_user
    #   redirect_to unauthorized_path
    # end
    # return render_not_found(:forbidden) if @event.user != current_user
  end

  def edit 
    @event = Event.find_by_id(params[:id])
    return render_not_found if @event.blank?
    return render_not_found(:forbidden) if @event.user != current_user
  end 

  def update
    @event = Event.find_by_id(params[:id])
    return render_not_found if @event.blank?
    return render_not_found(:forbidden) if @event.user != current_user
    @event.update_attributes(event_params)

    if @event.valid?
      redirect_to root_path
    else
      return render :edit, status: :unprocessable_entity
    end
  end

  def destroy 
    @event = Event.find_by_id(params[:id])
    return render_not_found if @event.blank?
    return render_not_found(:forbidden) if @event.user != current_user
    @event.destroy
    redirect_to root_path
  end 

  def new
    @event = Event.new
  end

  def create
    @event = current_user.events.create(event_params)
    if @event.valid?
      redirect_to event_path(current_user)
    else
      render :new, status: :unprocessable_entity
    end
  end
   
  private 

  def event_params 
    params.require(:event).permit(:title, :venue, :address, :city, :state, :country_select, :date, :arrival_time, :description)
  end

  def render_not_found(status=:not_found)
    render plain: "Unauthorized Access", status: status
  end
end

app/controllers/static_pages_controller.rb
class StaticPagesController < ApplicationController

attr_accessor :unauthorized

  def index
   
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/event_planner/events_helper.rb
module EventPlanner::EventsHelper
end

app/helpers/static_pages_helper.rb
module StaticPagesHelper
end

app/views/event_planner/events/index.html.erb
<html>
  <head>
  </head>
  <body>
    <div class="booyah-box col-10 offset-1">
      <div align="center">
        <h1> List of user events page </h1>
        <% @event.each do |event| %>
          <h2 class="text-center"><%= event.title %></h2>
          <div class="col-sm-4 col-12 text-center">
            <%= link_to 'See Event', event_planner_event_path(@event), class: 'btn btn-secondary' %>
          </div>
        <% end %>
      </div>
    </div>
  </body>
</html>

app/views/event_planner/events/new.html.erb
<html>
  <head>
  </head>
  <body>
    <div class="booyah-box col-10 offset-1">
      <div align="center">
        <h1>Create a New Event</h1>
        <%= simple_form_for @event, url: event_planner_events_path do |f| %>
        <%= f.input :title %>
        <%= f.input :venue %>
        <%= f.input :address %>
        <%= f.input :city %>
        <%= f.input :state %>
        <%= f.input :country_select %>
        <%= f.input :date %>
        <%= f.input :arrival_time %>
        <%= f.input :description %>
        <%= f.submit "Create", class: 'btn btn-secondary' %>
        <% end %>
      </div>
    </div>
  </body>
</html>

app/views/event_planner/events/show.html.erb
<html>
  <head>
  </head>
  <body>
    <div class="booyah-box col-10 offset-1">
      <div align="center">
        <h1> Specific Event Show Page </h1>
        <h3>User</h3><%= @event.user_id %>  
        <br />
        <h3>Event Number</h3><%= @event.id %>        
      </div>
    </div>
  </body>
</html>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Seeyousoon</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <div id="flex-content-container">
      <nav class="navbar navbar-toggleable-md navbar-inverse bg-inverse">
        <button class="navbar-toggler navbar-toggler-right" type="button" data-toggle="collapse" data-target="#navbarTogglerDemo02" aria-controls="navbarTogglerDemo02" aria-expanded="false" aria-label="Toggle navigation">
          <span class="navbar-toggler-icon"></span>
        </button>
        <a class="navbar-brand" href= / >seeyousoon</a>

        <div class="collapse navbar-collapse" id="navbarTogglerDemo02">
          <ul class="navbar-nav">
            <% if user_signed_in? %>
              <li class="nav-item">
                <%= link_to 'Create a New Event',
                new_event_planner_event_path, class: 'nav-link' %>
              </li>
              <li class="nav-item">
                <%= link_to 'My Events Page', event_planner_events_path(current_user), class: 'nav-link' %>   
              </li> 
              <li class="nav-item">
                <%= link_to 'Sign Out', destroy_user_session_path, method: :delete, class: 'nav-link' %>
              </li>
            <% else %>
              <li class="nav-item">
                <%= link_to 'Sign In', new_user_session_path, class: 'nav-link' %>
              </li>
              <li class="nav-item">
                <%= link_to 'Sign up', new_user_registration_path, class: 'nav-link' %>
              </li>
            <% end %>
          </ul>
        </div>
      </nav>


      <% if notice.present? %>
        <p class="alert alert-info"><%= notice %></p>
      <% end %>
      <% if alert.present? %>
        <p class="alert alert-danger"><%= alert %></p>
      <% end %>

      <%= yield %>
    </div>

    <div id="footer">
<!--       <div class="container">
        <b>Footer Here</b>
        <br />
        <%= link_to 'Create a New Event', new_event_planner_event_path %>
      </div>
 -->    </div>
  </body>
</html>

app/views/static_pages/index.html.erb
<html>
  <head>
  </head>
  <body>
     <div class="booyah-box col-10 offset-1">
      <div align="center">
        <h1> Page That Everyone Sees </h1>
      </div>
      <div class="row feature text-center">
<!-- 
          <%= link_to 'Sign In', new_user_session_path, class: 'nav-link' %> -->
<!--         <div class="col-12 col-sm">
          <h3>Edit</h3>
        </div>

        <div class="col-12 col-sm">
          <h3>Update</h3>
        </div>

        <div class="col-12 col-sm">
          <h3>Delete</h3> -->
        </div>
      </div>
    </div>
  </body>
</html>

app/views/static_pages/unauthorized.html.erb
<html>
  <head>
  </head>
  <body>
    <h1>Unauthorized Access</h1>
  </body>
</html>